#include <SoftwareSerial.h>

#include <Arduino.h>

/*
  Serial Event example

  When new serial data arrives, this sketch adds it to a String.
  When a newline is received, the loop prints the string and clears it.

  A good test for this is to try it with a GPS receiver that sends out
  NMEA 0183 sentences.

  NOTE: The serialEvent() feature is not available on the Leonardo, Micro, or
  other ATmega32U4 based boards.

  created 9 May 2011
  by Tom Igoe

  This example code is in the public domain.

  http://www.arduino.cc/en/Tutorial/SerialEvent
*/
#include "FastLED.h"// Fastled library to control the LEDs

String inputString = "";         // a String to hold incoming data
bool stringComplete = false;  // whether the string is complete
SoftwareSerial mySerial(10,5);
// How many leds are connected?
#define NUM_LEDS 144

// Define the Data Pin
#define DATA_PIN 6  // Connected to the data pin of the first LED strip


// Define the array of leds
CRGB leds[NUM_LEDS];

int pixelNum=0;


void serialEvent();
void setup() {
  // initialize serial:
  Serial.begin(115200);
  // reserve 200 bytes for the inputString:
  inputString.reserve(200);

  mySerial.begin(115200);
  mySerial.println("Hello, world?");
  
  FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS); // Init of the Fastled library
  FastLED.setBrightness(45);
   
   Serial.print("1");//put camera in bitmap mode

     Serial.print("0");//get picture

}

void loop() {
  

  
  // print the string when a newline arrives:
  if (stringComplete) {
//    Serial.print("input=");
//    Serial.print(inputString);
 mySerial.print("pixel=");
    mySerial.print(pixelNum);
    leds[pixelNum].r=inputString[0];
    leds[pixelNum].g=inputString[1];
    leds[pixelNum].b=inputString[2];

        FastLED.show();

mySerial.print("RBG = ");
mySerial.print(leds[pixelNum].r);
mySerial.print(", ");
mySerial.print(leds[pixelNum].g);
mySerial.print(", ");
mySerial.print(leds[pixelNum].b);
mySerial.print("\n");
    // clear the string:
    inputString = "";
    stringComplete = false;
    pixelNum++;
  }
  if(pixelNum == NUM_LEDS){
    pixelNum=0; //reset to first LED
    Serial.print("1");//put camera in bitmap mode
    Serial.print("0");//get picture
  }
}

/*
  SerialEvent occurs whenever a new data comes in the hardware serial RX. This
  routine is run between each time loop() runs, so using delay inside loop can
  delay response. Multiple bytes of data may be available.
*/
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag so the main loop can
    // do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    }
  }
}
